import { NWFilter } from "../../api/NWFilterApi";
import { SelectInput } from "./SelectInput";

export function NWFilterSelectInput(p: {
  editable: boolean;
  label?: string;
  nwfilters: NWFilter[];
  value?: string;
  onChange?: (name?: string) => void;
  canBeNull: boolean;
}): React.ReactElement {
  return (
    <SelectInput
      editable={p.editable}
      label={p.label ?? "Network filter"}
      value={p.value}
      onValueChange={(v) => p.onChange?.(v)}
      options={[
        ...(p.canBeNull
          ? [{ label: "No network filer", value: undefined }]
          : []),
        ...p.nwfilters.map((v) => {
          return {
            value: v.name,
            label: `${v.name} (${v.chain?.protocol ?? "unspecified"})`,
            description: `${v.rules.length} rules - ${v.join_filters.length} joint filters`,
          };
        }),
      ]}
    />
  );
}
